﻿--[[
--                                           MOUNTY ©2009 through 2011 or (c)2009 through 2011
--                                                         by William B. Steele
--                                              [ Draewind <> Silver Hand US <> Alliance ]
--                                                         WOWUI@CompuBall.com
--   
--		This program is free software: you can redistribute it and/or modifyit under the terms of the GNU General Public License as published by
--		the Free Software Foundation, either version 3 of the License, or(at your option) any later version.
		
--		This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
--		MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

--		You should have received a copy of the GNU General Public License along with this program.  If not, see <http://www.gnu.org/licenses/>
--]]
--[[
--]]
--------------------------------------------------------------------------------------------------------------------------------
-- Global Variables
--------------------------------------------------------------------------------------------------------------------------------
local Ability = {};
Ability["Ride"] = false;
Ability["Fly"] = false;
Ability["Vashj"] = false;

Ability["Location"] = {
	["Northrend"] = false;
	["Outland"] = false;
	["Kalimdor"] = false;
	["Eastern"] = false;
	["Maelstrom"] = false;
};
Ability["Skill"] = {
	["Apprentice"] = false;
	["Journeyman"] = false;
	["Expert"] = false;
	["Artisan"] = false;
	["Master"] = false;
	["Journeyman"] = false;
	["Cold"] = false;
	["License"] = false;
};
local Continent = "Unknown";

local Vashj = {
	["name"] = "Unknown";
	["coord"] = 0;
};

local Mount = {};

local Flyable = false;

local State = {
	["IsMounted"] = false;
	["IsFlying"] = false;
}

local Macro = {
	["SAVE"] = 1;
	["MAXGEN"] = 36;
	["MAXCHAR"] = 18;
	["FIRSTGEN"] = 1;
	["FIRSTCHAR"] = 16777217;
	["LASTGEN"] = 18;
	["LASTCHAR"] = 16777234;
	["NAME"] = "          ";
	["iconTexture"] = "Interface\\Icons\\INV_Misc_QuestionMark";

	["Index"] = 0;
	["ID"] = 0;
	["perChar"] = false;
	["GENSPACE"] = false;
	["CHARSPACE"] = false;
	["iconNum"] = 1;
	["noflyzone"] = false;
	["rewrite"] = true;
	["safeflytxt"] = MOUNTY_SAFEFLY;
	["flyable"] = false;
	["combatflag"] = false;
	["Using"] = false;
	["Writing"] = false;
};

local Button = {
	[1] = "LeftButton";
	[2] = "RightButton";
	[3] = "MiddleButton";
	[4] = "Button4";
	[5] = "Button5";
	["LeftButton"] = 1;
	["RightButton"] = 2;
	["MiddleButton"] = 3;
	["Button4"] = 4;
	["Button5"] = 5;
	["Modifier"] = "nomod";
	["modNim"] = 0;
	["nomod"] = true;
	["Shift"] = false;
	["Ctrl"] = false;
	["Alt"] = false;
}

local Wintergrasp = {
	["Flag"] = false;
	["Timer"] = true;
}

local FirstUse = true;

--------------------------------------------------------------------------------------------------------------------------------
-- Initialization
--------------------------------------------------------------------------------------------------------------------------------
function Mounty_InitializeVar()
	Mounty["Name"] = MOUNTY_NAME;
	Mounty["Version"] = MOUNTY_VERSION;
	Mounty["FileNumber"] = MOUNTY_FILENUM;
	Mounty["Player"] = UnitName("player");
	Mounty["Realm"] = GetRealmName();
	Mounty_SetAll();
end

function Mounty_SetAll()
	Mounty_ResetVersion();
	Mounty_GetMountList();
	Mounty_VashjCheck();
	Mounty_SetFlyable();
	if Mounty_SetEnable()then
		Mounty_WriteMacro(true);		
	end
end

function Mounty_ResetVersion()
	local fly, ride, pchar, safe, enabled = "", "", false, true, true;
	if Mounty.Ride.Text or Mounty.Fly.Text then
		if Mounty.Ride.Text then
			ride = Mounty.Ride.Text;
		end
		if Mounty.Fly.Text then
			fly = Mounty.Fly.Text;
		end
		pchar = Mounty.perChar;
		safe = Mounty.SafeFly;
		enabled = Mounty.Enabled;
		
		Mounty_Reset();
		Mounty.Fly.nomod.name = fly;
		Mounty.Ride.nomod.name = ride;
		Mounty.perChar = pchar;
		Mounty.SafeFly = safe;
		Mounty.Enabled = enabled;
		Mounty_GetMountList();
	end
	if not Mounty.Ride.Shift then
		fly = Mounty.Fly.nomod.name;
		ride = Mounty.Ride.nomod.name;
		pchar = Mounty.perChar;
		safe = Mounty.SafeFly;
		enabled = Mounty.Enabled;
		
		Mounty_Reset();
		Mounty.Fly.nomod.name = fly;
		Mounty.Ride.nomod.name = ride;
		Mounty.perChar = pchar;
		Mounty.SafeFly = safe;
		Mounty.Enabled = enabled;
		Mounty_GetMountList();
	end
end

function Mounty_Reset()
	Mounty = nil;
	Mounty ={};
	Mounty["Name"] = MOUNTY_NAME;
	Mounty["Version"] = MOUNTY_VERSION;
	Mounty["FileNumber"] = MOUNTY_FILENUM;
	Mounty["Player"] = UnitName("player");
	Mounty["Realm"] = GetRealmName();
	Mounty["SelectEnable"] = true;
	Mounty["Enabled"] = false;
	Mounty["SafeFly"] = true;
	Mounty["perChar"] = false;
	Mounty["Fly"] = {}
	Mounty.Fly["nomod"] = {};
	Mounty.Fly.nomod["name"] = "None Set";
	Mounty.Fly.nomod["coord"] = 0;
	Mounty["Ride"] = {}
	Mounty.Ride["nomod"] = {};
	Mounty.Ride.nomod["name"] = "None Set";
	Mounty.Ride.nomod["coord"] = 0;
	Mounty.Ride["Shift"] = {};
	Mounty.Ride.Shift["name"] = "None Set";
	Mounty.Ride.Shift["coord"] = 0;
	Mounty.Fly["Shift"] = {};
	Mounty.Fly.Shift["name"] = "None Set";
	Mounty.Fly.Shift["coord"] = 0;
end

function Mounty_Use()
	local button = Mounty_GetMacroButton();
	if FirstUse then
		Mounty_SetAll();
		FirstUse = false;
	end
	if(Macro.Writing == false) then
		Macro.Using = true;
		Mounty_SetStateVariables();
		if(State.IsMounted) then
			Mounty_VehicleExit();
		else
			local fly = Mounty_SetFlyable();
			local flyid = Mounty.Fly[Button.Modifier].coord;
			local rideid = Mounty.Ride[Button.Modifier].coord;
			local flyname = Mounty.Fly[Button.Modifier].name;
			local ridename = Mounty.Ride[Button.Modifier].name;
-- Vashj'ir segment -------------------------------------------------
			if MOUNTY_VASHJ_FLAG then
				if Ability.Vashj then
					fly = true; --- for the nonflyable returns that occur
					local modifier = Button.Modifier;
					if modifier == "nomod" then
						flyid = Vashj.coord;
						flyname = Vashj.name;
					end				
					if modifier == "Shift" then
						flyid = Mounty.Fly.nomod.coord;
						flyname = Mounty.Fly.nomod.name;
						if not Ability.Fly then
							flyid = Vashj.coord;
							flyname = Vashj.name;
						end
					end
				end				
			end
---------------------------------------------------------------------
			if(button == 2) then
				fly = false;
			end
			if fly then
				CallCompanion("MOUNT", flyid)
			else
				CallCompanion("MOUNT", rideid)
			end
		end
		Macro.Using = false;
	end
end

function Mounty_VehicleExit()
	local dismount = false;
	if not Mounty.SafeFly then
		dismount = true;
	end
	if IsFlying() then
		State.IsFlying = true;
	else
		dismount = true;
	end
	local buttonNumber = Mounty_GetMacroButton();
	if(buttonNumber == 2) then
		dismount = true;
	end

	if dismount then
		local test = CanExitVehicle();
		if (test == 1) then
			VehicleExit();
		else
			DismissCompanion("MOUNT");
		end
	end
end

function Mounty_GetMacroButton()
	local buttonNumber = 0;
	local buttonString = "None";
--	local macroIndex = GetRunningMacro();
	buttonString = GetRunningMacroButton();
	buttonNumber = Button[buttonString];
	Mounty_GetModifierKey();
	if Button.Alt then
		buttonNumber = 2;
	end
	return buttonNumber, buttonString;
end

function Mounty_GetModifierKey()
	local rt = {};
	Button.Modifier = "nomod";
	Button.modNum = 0;
	Button.nomod = true;
	Button.Shift = false;
	Button.Ctrl = false;
	Button.Alt = false;
	
	if(IsModifierKeyDown() == 1) then
		Button.nomod = false;
		if(IsAltKeyDown() == 1) then
			Button.modNum = Button.modNum + 3;
			Button.Modifier = "Alt";
			Button[Button.Modifier] = true;
		end
		if(IsControlKeyDown() == 1) then
			Button.modNum = Button.modNum + 20;
			Button.Modifier = "Ctrl";
			Button[Button.Modifier] = true;
		end
		if(IsShiftKeyDown() == 1) then
			Button.modNum = Button.modNum + 100;
			Button.Modifier = "Shift";
			Button[Button.Modifier] = true;
		end
		if Button.Modifier == "Ctrl" or Button.Modifier == "Alt" then
			Button.Modifier = "nomod";
		end
	end
--	Button.modNum:
--	100	= shift
--	20	= ctrl
--	3	= alt
--	120	= shift+ctrl
--	103	= shift+alt
end

--------------------------------------------------------------------------------------------------------------------------------
-- Initial Support and Slash Command
--------------------------------------------------------------------------------------------------------------------------------
function Mounty_SetEnable()
	Mounty.Enabled = false;
	if Ability.Ride and Mount.default.ride > 0 then
		Mounty.Enabled = Mounty.SelectEnable;
	end
	local test = Mounty_FindMacro();
	if Mounty.Enabled then
		if test < 0 then
		 	PlaySoundFile(MOUNTY_ErrorSound);
	  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000---------------------------------");
	  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000NO SPACE to create <Mounty MACRO>|r");
	  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000---------------------------------");
		end
	end
	return Mounty.Enabled;
end

function Mounty_Enable()
	if Mounty_CombatCheck() then
		if not Mounty.SelectEnable then
			Mounty.SelectEnable = true;
			Mounty_SetAll();
 			Mounty_PrintSettings(true);
		else
		 	PlaySoundFile(MOUNTY_ErrorSound);
	  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000<Mounty> is already selcted to Enabled.|r");
		end
	else  
  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000<Mounty> Action not permitted during combat.|r");
	end
	Mounty_WriteMacro();		
end

function Mounty_Disable()
	if Mounty_CombatCheck() then
		if Mounty.Enabled then
			Mounty_DeleteMacro();
			Mounty.SelectEnable = false;
			Mounty.Enabled = false;
			Mounty_SetAll();
 			Mounty_PrintSettings(true);
		else
		 	PlaySoundFile(MOUNTY_ErrorSound);
	  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000<Mounty> is already selcted to Disabled.|r");
		end
	else  
  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000<Mounty> Action not permitted during combat.|r");
	end  
end

function Mounty_perCharToggle()
	Mounty_DeleteMacro();
	local entry = Mounty.perChar;
	Mounty_GetMacroSpace();
	if(Mounty.perChar) then
		if(Macro.GENSPACE) then
			Mounty.perChar = false;
		end
	else
		if(Macro.CHARSPACE) then
			Mounty.perChar = true;
		end
	end
	if(entry == Mounty.perChar) then
	 	PlaySoundFile(MOUNTY_ErrorSound);
  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000--------------------------");
  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000UNABLE to move MACRO!! -- No Space|r");
  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000--------------------------");
	elseif (Mounty.perChar) then
	 	PlaySoundFile(MOUNTY_ActionSound);
 		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff-----------------------------------");
  		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty Macro> is now in the|r|cff00ff00 Character Specific Tab.|r");
  		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff-----------------------------------");
  	else
	 	PlaySoundFile(MOUNTY_ActionSound);
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff-----------------------------------");
  		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty Macro> is now in the|r|cff00ff00 General Tab.|r");
  		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff-----------------------------------");
   	end
	Mounty_WriteMacro();		
end

function Mounty_SafeFlyToggle()
		if Mounty.SafeFly then
			Mounty.SafeFly = false;
			Macro.safeflytxt = " ";
		   	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty SafeFly>|r is|cffff0000 Off|r");
		else
			Mounty.SafeFly = true;
			Macro.safeflytxt = MOUNTY_SAFEFLY;
		   	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty SafeFly>|r is|cff00ff00 On|r");
		end
end

function Mounty_SetFlyable()
	local fly = false;
	if Ability.Fly then
		Flyable = Ability.Location[Continent];
		if Flyable then
			Flyable = Mounty_WintergraspCheck();
		end
	end
	Macro.flyable = Flyable;
	if IsFlyableArea() or Wintergrasp.Flag then
		fly = Flyable;
	end
	Flyable = fly;
	return fly;
end

function Mounty_GetContinentName()
	SetMapToCurrentZone();
	local contNum = GetCurrentMapContinent();
	local continent = "Unkown";
	if(contNum > 0) then
		continent = select(contNum, GetMapContinents());
--DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> Continent Name = "..continent.."|r");
--DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> Continent Number = "..contNum.."|r");
	end
	Continent = Mounty_ConvertZoneName(continent);
	MOUNTY_ZONE = continent;
	return continent;
end

function Mounty_ConvertZoneName(zone)
	if (zone == "Eastern Kingdoms") then
		zone = "Eastern";
	end
	if (zone == "The Maelstrom") then
		zone = "Maelstrom";
	end
	return zone;
end

function Mounty_VashjCheck()
	local returnvalue = false;
	local old = MOUNTY_VASHJ_FLAG;
	MOUNTY_VASHJ_FLAG = false;
	local continent = Mounty_GetContinentName();
	if (continent == "Eastern Kingdoms") then
		local continentid = GetCurrentMapContinent();
		local zones = {GetMapZones(continentid)};
		MOUNTY_ZONE = zones[GetCurrentMapZone()]
		if (MOUNTY_ZONE == "Abyssal Depths") then
			MOUNTY_ZONE = MOUNTY_VASHJ_TEXT;
		elseif (MOUNTY_ZONE == "Kelp'thar Forest") then
			MOUNTY_ZONE = MOUNTY_VASHJ_TEXT;
		elseif (MOUNTY_ZONE == "Shimmering Expanse") then
			MOUNTY_ZONE = MOUNTY_VASHJ_TEXT;
		elseif (MOUNTY_ZONE == "Vashj'ir") then
			MOUNTY_ZONE = MOUNTY_VASHJ_TEXT;
		end
		if (MOUNTY_VASHJ_TEXT == MOUNTY_ZONE) then
			MOUNTY_VASHJ_FLAG = true;
		else
			MOUNTY_VASHJ_FLAG = false;
		end
	end
	if old then
		if not MOUNTY_VASHJ_FLAG then
			returnvalue = true;
		end
	else
		if MOUNTY_VASHJ_FLAG then
			returnvalue = true;
		end
	end
	return returnvalue;
end

function Mounty_Wintergrasp()
	local timer = false;
	if (GetWintergraspWaitTime()) then
		timer = true;
	end
	Wintergrasp.Flag = false;
	Wintergrasp.Timer = true;
	if ("Wintergrasp" == GetRealZoneText()) then
		Wintergrasp.Flag = true;
		Wintergrasp.Timer = timer;
	end
	return timer;
end

function Mounty_WintergraspCheck()
	Mounty_Wintergrasp();
	local timer = Wintergrasp.Timer;
	return timer;
end

function Mounty_SetStateVariables()
	State.IsMounted = false;
	State.IsFlying = false;
	local vehicle = false;
	local taxi = UnitOnTaxi("player");
	if taxi ~= 1 then
		if CanExitVehicle() then
			vehicle = true;
		end
		if IsMounted() or vehicle then
			State.IsMounted = true;
		end
		if IsFlying() then
			State.IsFlying = true;
		end
	end
	return vehicle;
end

function Mounty_CombatCheck()
	local combatcheck = true;
	if InCombatLockdown() then
		combatcheck = nil;
	end
	return combatcheck;
end

function Mounty_ExitCombat()
	if (Macro.combatflag == true) then
		Macro.combatflag = false;
		Mounty_WriteMacro();		
	end
end

--------------------------------------------------------------------------------------------------------------------------------
-- Macro
--------------------------------------------------------------------------------------------------------------------------------
function Mounty_WriteMacro()
	if Mounty_CombatCheck() then
		if not Macro.Using then
			Macro.Writing = true;
			local macroID;
			local macroIndex = Mounty_FindMacro();
			if macroIndex == 0 then
				local iconNum, serv, perChar, eperChar = Mounty_SetMacroValues();
				local body = Mounty_SetMacroBody();
				macroID = CreateMacro(Macro.NAME, iconNum, body, perChar, serv);
				Macro.Index = Mounty_FindMacro();
			elseif macroIndex > 0 then
				local iconNum, serv, perChar, eperChar = Mounty_SetMacroValues();
				local body = Mounty_SetMacroBody();
				macroID = EditMacro(macroIndex, Macro.NAME, iconNum, body, serv, eperChar);
				Macro.Index = macroIndex;
			elseif macroIndex < 0 then
			 	PlaySoundFile(MOUNTY_ErrorSound);
		  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000---------------------------------");
		  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000NO SPACE to create <Mounty MACRO>|r");
		  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000---------------------------------");
		  		Macro.Index = 0;
		   		Mounty_Disable();
			end
			Macro.Writing = false;
		end
	else
		Macro.combatflag = true;
	end
end

function Mounty_SetMacroBody()
	Mounty_GetMountList();
	Mounty_SetFlyable();
	local textline = {
		[1] ="";
		[2] ="";
	};
	local flyable = ",flyable\]";
	if Wintergrasp.Flag then
		flyable = "\]";
	end
	
	local flynomod = Mounty.Fly.nomod.name;
	local flyshift = Mounty.Fly.Shift.name;
	local ridenomod = Mounty.Ride.nomod.name;
	local rideshift = Mounty.Ride.Shift.name;
-- Vashj'ir segment -------------------------------------------------
	if MOUNTY_VASHJ_FLAG then
		if Ability.Vashj then
			Macro.flyable = true;
			flyable = "\]";
			flynomod = Vashj.name;
			flyshift = Mounty.Fly.nomod.name;
			if not Ability.Fly then
				flyshift = Vashj.name;
			end
		end
	end
----------------------------------------------------------------------
--	Line 1
	if(Macro.flyable) then
		textline[1] = "#showtooltip \[mod:alt,mod:shift\]"..rideshift..";\[nomod:alt,mod:shift"..flyable..flyshift..";\[nomod:alt"..flyable..flynomod..";\[mod:alt\]"..ridenomod..";"..ridenomod.."\n";
	else
		textline[1] = "#showtooltip \[mod:shift\]"..rideshift..";"..ridenomod.."\n";
	end
	
--	Line 2
	textline[2] = "/run Mounty_Use()\n";

	body = textline[1]..textline[2];
	return body;
end

function Mounty_SetMacroValues()
	local iconTexture = Macro.iconTexture;
	local iconNum = Macro.iconNum;
	local perChar = nil;
	local eperChar = 0;
	local serv = Macro.SAVE;
	if(Mounty.perChar) then
		perChar = 1;
		eperChar = 1;
	end
	Macro.perChar = Mounty.perChar;
	return iconNum, serv, perChar, eperChar;
end

function Mounty_FindMacro()
	local space = Mounty_GetMacroSpace();
	local index = GetMacroIndexByName(Macro.NAME);
	local returnindex = index;
	if(index == 0) then
		if(Mounty.perChar) then
			if not Macro.CHARSPACE then
				returnindex = returnindex - 1;
			end
		else
			if not Macro.GENSPACE then
				returnindex = returnindex - 1;
			end
		end
	end
	if returnindex < 0 then
		if space then
			Mounty_perCharToggle();
			returnindex = 0;
		end
	end
	return returnindex;
end

function Mounty_GetMacroSpace()
	local space = false;
	local numgen,numperchar = GetNumMacros();
	if(numgen < Macro.MAXGEN) then
		Macro.GENSPACE = true;
		space = true;
	end
	if(numperchar < Macro.MAXCHAR) then
		Macro.CHARSPACE = true;
		space = true;
	end
	return space;
end

function Mounty_DeleteMacro()
	local index = Mounty_FindMacro();
	if(index>0) then
		DeleteMacro(index);
	end
end

--------------------------------------------------------------------------------------------------------------------------------
-- Mounts
--------------------------------------------------------------------------------------------------------------------------------
function Mounty_GetMountList()
	Mounty_GetRidingSkill();
	if Ability.Ride then
		Mount = nil;
		Mount = {};
		Mount["Active"] = 0;
		Mount["default"] = {};
		Mount.default["ride"] = 0;
		Mount.default["fly"] = 0;
		Vashj.name = "Unknown"
		Vashj.coord = 0;
		Ability.Vashj = "false"
		local i, ii = 1, GetNumCompanions("MOUNT");
		Mount.ii = ii;
		if(ii > 0) then
			for i=1,ii do
				local ID, ctn, spellID, icon, issummoned = GetCompanionInfo("MOUNT", i);
				local level, n = Mounty_AddMountList(ctn, spellID);
				-- 1 = slow ride
				-- 2 = fast ride
				-- 3 = slow fly
				-- 4 = fast fly
				-- 5 = variable	(ride and fly)
				-- 6 = variable (ride only)
				-- 7 = seahorse swim mount in Vashj'r		
				if level == 7 then
					Ability.Vashj = true;
					Vashj.name = n;
					Vashj.coord = i;
				end
				Mount[i] = n;
				if n == Mounty.Ride.nomod.name then
					Mounty.Ride.nomod.coord = i;
				end
				if n == Mounty.Fly.nomod.name then
					Mounty.Fly.nomod.coord = i;
				end
				if n == Mounty.Ride.Shift.name then
					Mounty.Ride.Shift.coord = i;
				end
				if n == Mounty.Fly.Shift.name then
					Mounty.Fly.Shift.coord = i;
				end
				if n == Mounty.Fly.Shift.name then
					Mounty.Fly.Shift.coord = i;
				end
	
				if Mount[n] then Mount[n] = nil; end
				Mount[n] = {};
				Mount[n]["ctname"] = ctn;
				Mount[n]["spellID"] = spellID;
				Mount[n]["icon"] = icon;
				Mount[n]["level"] = level;
				if issummoned then Mount.Active = i; end
				if Mount.default.ride == 0 then
					if level == 1 or level == 2 then
						Mount.default.ride = i;
					end
				end
				if Mount.default.fly == 0 then
					if level == 3 or level == 4 then
						Mount.default.fly = i;
					end
				end
				if level == 5 then
					Mount.default.ride = i;
					Mount.default.fly = i;
				end
			end
		end
		Mounty_CheckDefaultMount();
	end
end

function Mounty_SetMount(flyorride)
	Mounty_GetMountList();
	local name, level, coord = "Not Mounted", 0, 0;
	local active = Mount.Active;
	if active == 0 then
	 	PlaySoundFile(MOUNTY_ErrorSound);
  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000Mount is not Set|r");
   		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000"..Mounty.Player.." must be mounted to Set a mount.|r");
   	else
   		name = Mount[active];
   		level = Mount[name].level;
   		coord = Mount[name].coord;
   		if level == 5 then
   			if not flyorride then
			 	PlaySoundFile(MOUNTY_ErrorSound);
		  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000Mount is not Set|r");
		  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000Unable to determine if setting flying mount or riding mount.|r");
		   		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000You must type /mty set fly or /mty set ride for this mount.|r");
		   	else
		   		if flyorride == "ride" then
		   			level = 2;
		   		elseif flyorride == "fly" then
		   			level = 4;
		   		else
				 	PlaySoundFile(MOUNTY_ErrorSound);
			  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000Mount is not Set|r");
			  		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000Unable to determine if setting flying mount or riding mount.|r");
			   		DEFAULT_CHAT_FRAME:AddMessage("|cffff0000You must type /mty set fly or /mty set ride for this mount.|r");
		   		end
   			end
   		end
   		Mounty_GetModifierKey();
   		if (level == 1) or (level == 2) or (level == 6) then
   			Mounty.Ride[Button.Modifier].name = name;
   			Mounty.Ride[Button.Modifier].coord = active;
 			Mounty_PrintSettings(true);
  		elseif (level == 3) or (level == 4) then
   			Mounty.Fly[Button.Modifier].name = name;
   			Mounty.Fly[Button.Modifier].coord = active;
			Mounty_PrintSettings(true);
   		end
		Mounty_WriteMacro();		
	end
end

function Mounty_CheckDefaultMount()
	if Mounty.Ride.nomod.name == "None Set" and Mount.default.ride > 0 then
		Mounty.Ride.nomod.name = Mount[Mount.default.ride];
		Mounty.Ride.nomod.coord = Mount.default.ride;
	end
	if Mounty.Fly.nomod.name == "None Set" and Mount.default.ride > 0 then
		Mounty.Fly.nomod.name = Mount[Mount.default.fly];
		Mounty.Fly.nomod.coord = Mount.default.fly;
	end
	if Mounty.Ride.Shift.name == "None Set" and Mount.default.ride > 0 then
		Mounty.Ride.Shift.name = Mounty.Ride.nomod.name;
		Mounty.Ride.Shift.coord = Mounty.Ride.nomod.coord;
	end
	if Mounty.Fly.Shift.name == "None Set" and Mount.default.ride > 0 then
		Mounty.Fly.Shift.name = Mounty.Fly.nomod.name;
		Mounty.Fly.Shift.coord = Mounty.Fly.nomod.coord;
	end
end

--------------------------------------------------------------------------------------------------------------------------------
-- Imported and converted/edited from Livestock (c)2008 by Scott Snowman (Recompense on Uldum(US))
-- Many thanks for helping accomplish this task!
--------------------------------------------------------------------------------------------------------------------------------
function Mounty_AddMountList(name, spellID)
	local returnName = name;
	local returnvalue = 1;
	local outland = false;
	local northrend = false;
	local very = false;
	local fast = false;
	local changes = false;
	local turtle = false;
	local blizzard = false;
	local seahorse = false;
--	GameTooltip_SetDefaultAnchor(MountyToolTip, UIParent)
	MountyToolTip:SetOwner(UIParent, "ANCHOR_NONE")
	MountyToolTip:SetHyperlink("spell:"..spellID) -- pull up the tooltip object we created and set it to the ID of the spell
	for i = 1, MountyToolTip:NumLines() do -- iterate over the number of lines in the tooltip
		local text = _G["MountyToolTipTextLeft"..i]:GetText() -- get the text from each line
		if(i == 1) then
			returnName = text;
		end
		for word in string.gmatch(text, "%S+") do -- look at each word in the line.  NOT %a+ because that apparently doesn't capture unicode characters, for the localized clients.
			if strfind(word, "Outland") then
				outland = true -- flying mounts have the word "Outland" in them
			elseif strfind(word, "Northrend") then
				northrend = true -- flying mounts also have the word "Northrend" in them.  Double verification just to be careful
			elseif strfind(word, "very") or strfind(word, "extremely") then
				very = true -- epic mounts have the phrase "very fast" in them.  Another double verification.  The arena mount has the phrase "extremely fast"
			elseif strfind(word, "fast") then
				fast = true
			elseif strfind(word, "changes") then
				changes = true -- There are now variable mounts!  These have the phrase "This mount changes depending on your Riding skill (and location)"  The location part is only for ones that can be land or flying mounts.
			elseif strfind(word, MOUNTY_VASHJ_TEXT) then
				seahorse = true -- seahorse mounts also have the word "Vashj'ir" in them
			end
		end
	end -- parse the tooltip.  The variables outland, northrend, very, fast, location, and changes are set to true if the corresponding text is found
	MountyToolTip:Hide(); -- hide our dummy tooltip
	
	if northrend or outland then -- if the tooltip contains either of these words, it's a flying mount
		returnvalue = 3;
	end
	
	if very and fast then -- if the tooltip contains both of these words, it's an epic mount of some sort. 
		returnvalue = returnvalue + 1;
	end
	
	if changes then -- overwrite the speed data to be variable and change the show setting to 1 to make sure it shows up
		returnvalue = 5;
	end
	if (returnvalue == 5) and blizzard then -- checking for BLizzard Bear mount (variable but ground only)
		returnvalue = 6;
	end
	if seahorse then -- change the type to be variable as well.  The show will already have been set in the above condition, because variable type mounts contain the phrase "changes based on Riding skill and location" 
		returnvalue = 7;
	end
	return returnvalue, returnName;
end

--------------------------------------------------------------------------------------------------------------------------------
-- Riding Skills
--------------------------------------------------------------------------------------------------------------------------------
function Mounty_GetRidingSkill()
	Mounty_ClearRidingSkill();
	local s, i, ii = 1, 1, MAX_SKILLLINE_TABS;
	local spell, spell1, spell2, spell3, spellsub = "", "", "", "", "";
	local isusable = nil;
	for i = 1, ii do
		local name, texture, offset, numSpells = GetSpellTabInfo(i, BOOKTYPE_SPELL);
		if name == "General" then
			for s = offset + 1, offset + numSpells do
				spell, spellsub = GetSpellBookItemName(s, BOOKTYPE_SPELL);
				isusable = IsUsableSpell(spell);
				if isusable then
					_,_,spell1, spell2 = string.find(spell, "(%S+) (%S+)");
					if spell == "Cold Weather Flying" then
						Mounty_SetRidingSkill("Cold Weather Flying");
					elseif spell == "Flight Master's License" then
						Mounty_SetRidingSkill("Flight Master's License");
					elseif spell2 == "Riding" then
						Mounty_SetRidingSkill(spell1);
					end
				end
			end
		end
	end
end

function Mounty_ClearRidingSkill()
	Ability.Ride = false;
	Ability.Fly = false;
	
	Ability.Location["Northrend"] = false;
	Ability.Location["Outland"] = false;
	Ability.Location["Kalimdor"] = false;
	Ability.Location["Eastern"] = false;
	Ability.Location["Maelstrom"] = false;
	
	Ability.Skill["Apprentice"] = false;
	Ability.Skill["Journeyman"] = false;
	Ability.Skill["Expert"] = false;
	Ability.Skill["Artisan"] = false;
	Ability.Skill["Master"] = false;
	Ability.Skill["Journeyman"] = false;
	Ability.Skill["Cold"] = false;
	Ability.Skill["License"] = false;
end

function Mounty_SetRidingSkill(name)
	if name == "Cold Weather Flying" then
		Ability.Skill["Cold"] = true;
		Ability.Location["Northrend"] = true;
	elseif name == "Flight Master's License" then
		Ability.Skill["License"] = true;
		Ability.Location["Kalimdor"] = true;
		Ability.Location["Eastern"] = true;
		Ability.Location["Maelstrom"] = true;
	elseif (name == "Expert") or (name == "Artisan") or (name == "Master") then
		Ability.Ride = true;
		Ability.Fly = true;
		Ability.Skill[name] = true;
		Ability.Location["Outland"] = true;
	elseif (name == "Apprentice") or (name == "Journeyman") then
		Ability.Ride = true;
	end
end

--------------------------------------------------------------------------------------------------------------------------------
-- Print Functions
--------------------------------------------------------------------------------------------------------------------------------
function Mounty_Message()
	Mounty_WriteMacro();		
	if Mounty.Enabled then
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff------------------------------");
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty>|r  File: Mounty_"..Mounty.FileNumber.."|cff0000ff by Drae|r");
	   	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty>|r|cff00ff00 Enabled|r");
		if Ability.Ride then
			DEFAULT_CHAT_FRAME:AddMessage("|cffffff00 ABILITIES:");
			if Ability.Skill.Apprentice then
				DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  "..Mounty.Player.."'s current Riding Skill level = Apprentice|r (Regular land mount).");
			elseif Ability.Skill.Journeyman then
				DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  "..Mounty.Player.."'s current Riding Skill level = Journeyman|r (Epic land mount).");
			elseif Ability.Skill.Expert then
				DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  "..Mounty.Player.."'s current Riding Skill level = Expert|r (Regular flying mount).");
			elseif Ability.Skill.Artisan then
				DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  "..Mounty.Player.."'s current Riding Skill level = Artisan|r (Epic flying mount).");
			elseif Ability.Skill.Master then
				DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  "..Mounty.Player.."'s current Riding Skill level = Master|r (310% flying mount).");
			end
			if Ability.Skill.Cold then
				DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  "..Mounty.Player.." has Cold Weather Flying.");
			end
			if Ability.Skill.License then
				DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  "..Mounty.Player.." has a Flight Master's License.");
			end
			if Mount.default.ride > 0 then
				DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty>|r "..Mounty.Player.." may ride in all continents.");
			else
				DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty>|r|cffff0000 "..Mounty.Player.." has no riding mounts.");
			end
			if Ability.Fly and Mount.default.fly > 0 then
				DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty>|r |cffffff00"..Mounty.Player.." may fly in:|r");
				if Ability.Location.Kalimdor then
					DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  Kalimdor =|r|cff00ff00 Yes|r");
				else
					DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  Kalimdor =|r|cffff0000 No|r");
				end
				if Ability.Location.Eastern then
					DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  Eastern Kingdoms =|r|cff00ff00 Yes|r");
				else
					DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  Eastern Kingdoms =|r|cffff0000 No|r");
				end
				if Ability.Location.Outland then
					DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  Outland =|r|cff00ff00 Yes|r");
				else
					DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  Outland =|r|cffff0000 No|r");
				end
				if Ability.Location.Northrend then
					DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  Northrend =|r|cff00ff00 Yes|r");
				else
					DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  Northrend =|r|cffff0000 No|r");
				end
				if Ability.Location.Maelstrom then
					DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  The Maelstrom =|r|cff00ff00 Yes|r");
				else
					DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  The Maelstrom =|r|cffff0000 No|r");
				end
			else
				DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty>|r |cffff0000 You are not able to fly (Skill/Mount).|r");
			end
		end
		Mounty_PrintSettings();
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00 MENU:");
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty>|r  File: Mounty_"..Mounty.FileNumber.."|cff0000ff by Drae|r");
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> Menu options:|r (use /mty or /mounty)");
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /mty|r Rewrites the <Mounty Macro> shows status and menu.");
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /mty|r|cff00ff00 safe|r Toggles Safefly on/off (default on)");
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /mty|r|cff00ff00 gen|r Places the <Mounty Macro> in the General Tab (Default).");
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /mty|r|cff00ff00 char|r Places the <Mounty Macro> in the Character Specific Tab.");
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff  /mty|r|cff00ff00 set|r Set current flying/riding mount.");
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00  Holding down \[Shift\] while pressing \[Enter\] on /mty set, will set the <Shift> mounts.");
	else
	   	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty>|r|cffff0000 Disabled|r");
	   	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty>|r| Type /mty enable (to enable Mounty)");
	end
end

function Mounty_PrintSettings(ding)
	if ding then
	 	PlaySoundFile(MOUNTY_ActionSound);
	end
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff------------------------------");
		DEFAULT_CHAT_FRAME:AddMessage("|cffffff00 SETTINGS:");
	if Mounty.SafeFly then
   	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty SafeFly>|r is|cff00ff00 On|r (right click or |cffff0000\[Alt\]|r to dismount while flying.)");
	else
	   	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty SafeFly>|r is|cffff0000 Off|r (left click to dismount while flying.");
	end
	if Mounty.perChar then
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty Macro> is in the|r|cff00ff00 Character Specific Tab.|r");
	else
		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty Macro> is in the|r|cff00ff00 General Tab.|r");
	end
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff------------------------------");
	if Mounty.Ride.nomod.coord > 0 then
	   	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Riding Mount> |r|cff00ff00"..Mounty.Ride.nomod.name.."|r");
	   	DEFAULT_CHAT_FRAME:AddMessage("|cffffff00<Shift Riding Mount> |r|cff00ff00"..Mounty.Ride.Shift.name.."|r");
	else
	   	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Riding Mount> |r|cff00ff00"..Mounty.Player.." is unable to ride.|r");
	end
	if Mounty.Fly.nomod.coord > 0 then
	   	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Flying Mount> |r|cff00ff00"..Mounty.Fly.nomod.name.."|r");
	   	DEFAULT_CHAT_FRAME:AddMessage("|cffffff00<Shift Flying Mount> |r|cff00ff00"..Mounty.Fly.Shift.name.."|r");
	else
	   	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Flying Mount> |r|cff00ff00"..Mounty.Player.." is unable to fly.|r");
	end
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff------------------------------");
end

function Mounty_BadMessage(message, badmessage)
	PlaySoundFile(MOUNTY_ErrorSound);
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff-- <Mounty> --|r|cffff0000 Unable to understand command: |r");
	DEFAULT_CHAT_FRAME:AddMessage("|cffffff00"..message.."|r|cff00ffff segment from:|r");
	DEFAULT_CHAT_FRAME:AddMessage("|cffffff00"..badmessage.."|r");
end

function Mounty_Test()
--	Mounty_VasjCheck();
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> MOUNTY_VASHJ_TEXT =|r|cff00ff00 <"..MOUNTY_VASHJ_TEXT..">|r");
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> MOUNTY_ZONE =|r|cff00ff00 <"..MOUNTY_ZONE..">|r");
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> Continent =|r|cff00ff00 <"..Continent..">|r");
	if MOUNTY_VASHJ_FLAG then
   		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> Vasj\'ir Flag =|r|cff00ff00 TRUE|r");
   	else
   		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> Vasj\'ir Flag =|r|cffff0000 FALSE|r");
   	end
	if Ability.Vashj then
   		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> Vasj\'ir Ability =|r|cff00ff00 TRUE|r");
   	else
   		DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> Vasj\'ir Ability =|r|cffff0000 FALSE|r");
   	end
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> Vasj\'ir Mount Name =|r|cff00ff00 "..Vashj.name.."|r");
	DEFAULT_CHAT_FRAME:AddMessage("|cff00ffff<Mounty> Vasj\'ir Mount ID =|r|cff00ff00 "..Vashj.coord.."|r");
end

